Index: trunk/DocHFI_L2/wbsl2.tex
===================================================================
--- trunk/DocHFI_L2/wbsl2.tex	(revision 811)
+++ trunk/DocHFI_L2/wbsl2.tex	(revision 811)
@@ -0,0 +1,329 @@
+\documentclass[twoside,12pt]{article}
+%  Package standard : Utilisation de caracteres accentues, mode francais et graphique
+\usepackage[latin1]{inputenc}
+\usepackage[T1]{fontenc}
+\usepackage{graphicx}
+
+%  Extension de symboles mathematiques
+\usepackage{amssymb}
+
+%  Definition de taille de page
+\setlength{\textwidth}{16cm}
+\setlength{\textheight}{21.5cm}
+\setlength{\topmargin}{0.5cm}
+\setlength{\oddsidemargin}{0.cm}
+\setlength{\evensidemargin}{0.cm}
+\setlength{\unitlength}{1mm}
+
+\newcommand{\bul}{$\bullet \ $}
+\newcommand{\gph}[1]{ {\bf GPH#1} }
+\newcommand{\ngph}[1]{ GPH#1 }
+
+\begin{document}
+
+\begin{titlepage}
+\vspace{1cm}
+\rule{110 mm}{0.5 mm}\makebox[50 mm]{\bf Planck HFI L2}
+\vspace{2cm}
+\begin{center}
+\par \renewcommand{\baselinestretch}{2.0} \small 
+{\LARGE \bf 
+Planck HFI L2 \\ 
+WBS - PBS
+}
+\par \renewcommand{\baselinestretch}{1.0} \normalsize
+\vspace{5 cm}
+\begin{tabular}{ll}
+{R. Ansari} & {\tt ansari@lal.in2p3.fr} \\
+{C. Mercier} & {\tt Claude.Mercier@ias.fr} \\
+{J.F. Sygnet} & {\tt Jean-Francois.Sygnet@ias.fr} \\
+% {É. Aubourg} & {\tt aubourg@hep.saclay.cea.fr} \\
+% {É. Lesquoy} & {\tt lesquoy@hep.saclay.cea.fr} \\
+% {C. Magneville} & {\tt cmv@hep.saclay.cea.fr} \\
+\end{tabular}
+
+\end{center}
+\vfill
+\hfill 
+% \includegraphics[width=4cm]{Fig/hfi_icon_vsmall.eps}
+\framebox[\textwidth]{\hspace{0.5cm} \bf Planck HFI Level 2 
+\hspace{1cm} \today }
+\end{titlepage}
+
+\tableofcontents
+
+\newpage
+% \tableofcontents
+
+\section*{HFI L2 processing software packages}
+This document contains a preliminary version a the 
+Work Breakdown Structure (WBS), Package Breakdown Structure 
+(PBS) for Planck-HFI Level 2 data processing.
+
+The different packages are listed here. It should be noted that
+all packages should be compliant with the general software 
+architecture and use the services of the corresponding 
+support modules (\gph{428}). \\
+
+\begin{itemize}
+\item[]\gph{421}  RTA/QLA : Real Time Assesment, Quick Look Analysis.
+\item[]\gph{422}  TOI processing
+\item[]\gph{423}  Polarised TOI processing
+\item[]\gph{424}  Simple 2-D map reconstruction from TOI's
+\item[]\gph{425}  Global 2-D map reconstruction
+\item[]\gph{426}  Global 2-D polarised map reconstruction
+\item[]\gph{427}  Early Compact Source Catalogue
+\item[]\gph{428}  General software architecture and support modules
+\item[]\gph{429}  Integration and Validation
+\end{itemize}
+
+Other related packages:
+\begin{itemize}
+\item[]\gph{320} Hardware, network and related software procurement
+and management
+\item[]\gph{140} Project management.
+\end{itemize}
+
+The table below shows a very preliminary cost estimate in
+FTE-MY (Full Time Equivalent Man Year) for each package. \\
+\begin{center}
+\begin{tabular}[h]{|c|c||c|c|}
+\hline
+\makebox[2.5cm][c]{Package} &  \makebox[2.5cm][c]{Cost} &  
+\makebox[2.5cm][c]{Package} &  \makebox[2.5cm][c]{Cost} \\
+\hline
+%               &           &           &       \\
+\ngph{421}     &   5     &     \ngph{426}     &   ?     \\
+%
+\ngph{422}     &   15    &     \ngph{427}     &   5     \\
+%
+\ngph{423}     &   15    &     \ngph{428}     &   30    \\
+%
+\ngph{424}     &   20    &     \ngph{429}     &   10    \\
+%
+\ngph{425}     &   ?     &                    &         \\
+%               &           &           &       \\
+%
+\hline 
+\ngph{320}     &   5     & \ngph{140}     &   5     \\
+\hline \hline
+\multicolumn{2}{c}{\bf Total}          &   \multicolumn{2}{c}{\bf 110 + ?} \\
+\hline 
+\end{tabular}
+% \caption{Preliminary cost estimate}
+\end{center}
+
+
+\newpage
+
+\section{GPH421: RTA/QLA Real Time Assesment, Quick Look Analysis}
+
+\section{GPH422: TOI  processing}
+
+This package contains all the processing which has to be 
+perfomed on TOI's (Time Ordered Information ) either single detector, or
+multpile detector, single frequency set of TOI's.
+
+\begin{itemize}
+
+\item[]\gph{422.1}  TOI statistical characterisation 
+\begin{itemize}
+\item Raw time-line statistical checks
+\item Noise statistic determination
+\item Low frequency drifts
+\end{itemize}
+
+\item[]\gph{422.2}  TOI filters
+\begin{itemize}
+\item Time domain filtering
+\item Fourier filtering
+\end{itemize}
+
+\item[]\gph{422.3}  Deglitching and source detection
+\begin{itemize}
+\item TOI deglitchers
+\item Point source detector
+\item Galaxy crossing detector
+\item CMB dipole finder 
+\end{itemize}
+
+\item[]\gph{422.4}  Astrometric calibration \\
+Astrometric calibration using point sources and galaxy crossing.
+
+\item[]\gph{422.5}  Photometric calibration \\
+Photometric calibration, using extended sources (Galaxy)
+
+\item[]\gph{422.6}  Single pointing co-added rings \\
+ 
+\item[]\gph{422.9}  Deliverables: Cleaned, calibrated TOI's : 
+\begin{itemize} 
+\item $(\alpha, \delta)$, roll angle, calibrated signal  
+\item Noise statistics
+\item Offset/drifts
+\item Co-added rings
+\end{itemize}
+
+\end{itemize}
+
+\section{GPH423: Polarised TOI processing}
+
+\gph{423.1} I.Q,U reconstruction from detector signals 
+in polarized channels
+
+\section{GPH424: Simple 2-D map reconstruction}
+
+This package contains all the necessary modules for 
+single frequency 2-D map reconstruction using the cleaned
+TOI's from \gph{422} and \gph{423}. However \gph{424}
+should only implement simple versions of 2-D map making 
+and systematic removal algorithms, as opposed to 
+\gph{424} which must provide a global, optimal 2-D map 
+reconstruction with systematic effects assessment.
+\begin{itemize} 
+
+\item[]\gph{424.1} 1D $\rightarrow$ 2D Projector
+\item[]\gph{424.2} Systematic effects estimation, subtraction 
+\begin{itemize}
+\item Low frequency noise estimation
+\item far side lobe subtraction
+\item far side determination using moon/earth during transfer, 
+commissioning phases.
+\end{itemize}
+
+\item[]\gph{424.3} Main lobe 
+\begin{itemize}
+\item Point source detection
+\item Main lobe reconstruction
+\end{itemize}
+
+
+\item[]\gph{424.4} Astrometric calibration
+\item[]\gph{424.5} Photometric calibration
+\item[]\gph{424.6} Postage stamp maps for compact sources
+
+\item[]\gph{424.9} Deliverables: Full sky maps \\
+\begin{itemize}
+\item Sky maps per frequency channels $map_\nu (\alpha, \delta) $
+\item Reprocessed TOI's 
+\end{itemize} 
+
+\end{itemize} 
+
+\section{GPH425: Global 2-D map reconstruction}
+
+Implementation of an optimal 2-D full sky map reconstruction,
+with systematics (low frequency drifts, side lobes, \ldots)
+estimation and removal. This package definition and 
+breakdown structure can only be refined at a later stage,
+after preliminary studies of applicable methods.
+
+\begin{itemize}
+
+\item[]\gph{425.9} Deliverables: Full sky maps \\
+\begin{itemize}
+\item Sky maps per frequency channels $map_\nu (\alpha, \delta) $
+\item Reprocessed, cleanead TOI's
+\item Lobe par detector and per frequency channel
+\item Systematics estimation 
+\end{itemize} 
+
+\end{itemize} 
+
+\section{GPH426: Global polarised 2-D map reconstruction}
+
+This module, a extended version of \gph{425} has to take 
+into account specific constraints related to polarised TOI's
+and sky map recosntruction
+
+\begin{itemize}
+
+\item[]\gph{426.9} Deliverables: Full sky maps for each 
+polarisation component (I,Q,U) \\
+\begin{itemize}
+\item Sky maps per frequency channels $map_\nu (\alpha, \delta) $
+for each component (I,Q,U)
+\item Reprocessed, cleanead TOI's for I,Q,U
+\item Noise and systematic effect maps and characteristics 
+\end{itemize} 
+
+\end{itemize} 
+
+
+\section{GPH427: Early Compact Source Catalogue} 
+
+\begin{itemize}
+
+\item[]\gph{427.9} Deliverables: Source catalogue \\
+\begin{itemize}
+\item Astrometrically calibrated source positions and 
+photometrically calibrated flux in each frequency band \\
+$$(\alpha, \delta)_i , F_i^\nu, i=1,..,N$$
+\item The corresponding local sky maps in each 
+frequency bands.
+\item Related software and documentation
+\end{itemize} 
+
+\end{itemize} 
+
+\section{GPH428: General software architecture and support modules}
+
+This package defines the general architecture for the level 2 processing
+software and insures the compliance with IDIS framework.
+It provides also the support modules for the different 
+level 2 packages (\gph{42x}) and their interfaces with IDIS 
+components.
+
+\begin{itemize}
+
+\item[]\gph{428.1} General architecture
+
+\item[]\gph{428.2} TOI manipulation module
+
+\item[]\gph{428.3} Maps manipulation module (Full and local sky maps)
+
+\item[]\gph{428.4} Instrument and satellite representation 
+\begin{itemize}
+\item Focal plane geometry
+\item Detector's frequency response
+\item Main and secondary Lobes 
+\item Orbit and attitude
+\item Thermal model
+\end{itemize} 
+
+\item[]\gph{428.5} Standard numerical analysis tools
+\begin{itemize}
+\item Arrays (Matrix, Vectors, \ldots) and linear algebra
+\item Fourier analysis, Wavelet analysis
+\item Minimisation, optimisation
+\item Statistical analysis
+\end{itemize} 
+
+\item[]\gph{428.6} Interface with DMC
+
+\item[]\gph{428.7} Interface with the process coordinator
+
+\end{itemize} 
+
+\section{GPH429: Integration and Validation}
+
+The assembly of the different L2 processing modules and
+integration in the pipeline, as well as the 
+assessment of the overall quality of the delivered 
+data products is the responsibility of \gph{429}
+
+\begin{itemize}
+ 
+\item[]\gph{429.9} Deliverables: Full sky maps for each 
+polarisation component (I,Q,U) \\
+\begin{itemize}
+\item Sky maps per frequency channels $map_\nu (\alpha, \delta) $
+for each component (I,Q,U)
+\item Reprocessed, cleanead TOI's for I,Q,U
+\item Noise and systematic effect maps and characteristics 
+\item Photometric and Astrometric calibration
+\item Associated software and documentation
+\end{itemize} 
+
+\end{itemize} 
+
+\end{document}